#!/usr/bin/env python
# -*- coding: utf-8 -*-

#  PostmasterGS Stamp Album Page Generator for Scribus v1.04 (20130706)
#  Brought to you by GermanStamps.net -- http://www.germanstamps.net
#
#  This script is free to use and modify.  However I have invested significant
#  time and effort ino this project, and I simply ask that you leave this block
#  of text intact as recognition of the source of the code.

from __future__ import division
import scribus
from decimal import *

global origUnit
origUnit = scribus.getUnit()
    
# These need to be complte filepaths.
# On a PC, they should be in a format like this -- "C:\Users\Jed\Documents\Stamps\PMGSSAPG_scribus10_setting.txt"
# On a Mac, they should be in a format like this -- "/Users/Jed/Documents/Stamps/PMGSSAPG_scribus10_settings.txt"
global strFileS
strFileS = "C:\Users\Jed\Desktop\PMGSSAPG_scribus10_settings.txt"
global strFileB
strFileB = "C:\Users\Jed\Desktop\PMGSSAPG_scribus10_batch.txt"

def funcImportSettings():
    '''Load the text file'''
    fileHandleS = open(strFileS, 'r')
    fileContentsS = fileHandleS.readlines()
    fileHandleS.close()
    fileContentsS = [item.rstrip('\r\n') for item in fileContentsS]

    '''Strip out the field identifiers to leave just the value, then assign to variables'''
    global strStyle
    strStyle = fileContentsS[0]
    strStyleI = strStyle.find("|")+1
    strStyleL = len(strStyle)
    strStyle = strStyle[strStyleI:strStyleL]
    global strFrameDouble
    strFrameDouble = fileContentsS[1]
    strFrameDoubleI = strFrameDouble.find("|")+1
    strFrameDoubleL = len(strFrameDouble)
    strFrameDouble = strFrameDouble[strFrameDoubleI:strFrameDoubleL]
    global strFrameSpacing
    strFrameSpacing = fileContentsS[2]
    strFrameSpacingI = strFrameSpacing.find("|")+1
    strFrameSpacingL = len(strFrameSpacing)
    strFrameSpacing = strFrameSpacing[strFrameSpacingI:strFrameSpacingL]
    global strFrameThicknessOuter
    strFrameThicknessOuter = fileContentsS[3]
    strFrameThicknessOuterI = strFrameThicknessOuter.find("|")+1
    strFrameThicknessOuterL = len(strFrameThicknessOuter)
    strFrameThicknessOuter = strFrameThicknessOuter[strFrameThicknessOuterI:strFrameThicknessOuterL]
    global strFrameThicknessInner
    strFrameThicknessInner = fileContentsS[4]
    strFrameThicknessInnerI = strFrameThicknessInner.find("|")+1
    strFrameThicknessInnerL = len(strFrameThicknessInner)
    strFrameThicknessInner = strFrameThicknessInner[strFrameThicknessInnerI:strFrameThicknessInnerL]
    global strPaddingTop
    strPaddingTop = fileContentsS[5]
    strPaddingTopI = strPaddingTop.find("|")+1
    strPaddingTopL = len(strPaddingTop)
    strPaddingTop = strPaddingTop[strPaddingTopI:strPaddingTopL]
    global strPaddingLeft
    strPaddingLeft = fileContentsS[6]
    strPaddingLeftI = strPaddingLeft.find("|")+1
    strPaddingLeftL = len(strPaddingLeft)
    strPaddingLeft = strPaddingLeft[strPaddingLeftI:strPaddingLeftL]
    global strMarginTop
    strMarginTop = fileContentsS[7]
    strMarginTopI = strMarginTop.find("|")+1
    strMarginTopL = len(strMarginTop)
    strMarginTop = strMarginTop[strMarginTopI:strMarginTopL]
    global strMarginBottom
    strMarginBottom = fileContentsS[8]
    strMarginBottomI = strMarginBottom.find("|")+1
    strMarginBottomL = len(strMarginBottom)
    strMarginBottom = strMarginBottom[strMarginBottomI:strMarginBottomL]
    global strMarginLeft
    strMarginLeft = fileContentsS[9]
    strMarginLeftI = strMarginLeft.find("|")+1
    strMarginLeftL = len(strMarginLeft)
    strMarginLeft = strMarginLeft[strMarginLeftI:strMarginLeftL]
    global strMarginRight
    strMarginRight = fileContentsS[10]
    strMarginRightI = strMarginRight.find("|")+1
    strMarginRightL = len(strMarginRight)
    strMarginRight = strMarginRight[strMarginRightI:strMarginRightL]
    global strVerticalSpacing
    strVerticalSpacing = fileContentsS[11]
    strVerticalSpacingI = strVerticalSpacing.find("|")+1
    strVerticalSpacingL = len(strVerticalSpacing)
    strVerticalSpacing = strVerticalSpacing[strVerticalSpacingI:strVerticalSpacingL]
    global strOISpacing
    strOISpacing = fileContentsS[12]
    strOISpacingI = strOISpacing.find("|")+1
    strOISpacingL = len(strOISpacing)
    strOISpacing = strOISpacing[strOISpacingI:strOISpacingL]
    global strTitleInclude
    strTitleInclude = fileContentsS[13]
    strTitleIncludeI = strTitleInclude.find("|")+1
    strTitleIncludeL = len(strTitleInclude)
    strTitleInclude = strTitleInclude[strTitleIncludeI:strTitleIncludeL]
    global strTitleIncludeP
    strTitleIncludeP = strTitleInclude
    global strTitleFont
    strTitleFont = fileContentsS[14]
    strTitleFontI = strTitleFont.find("|")+1
    strTitleFontL = len(strTitleFont)
    strTitleFont = strTitleFont[strTitleFontI:strTitleFontL]
    global strTitleFontSize
    strTitleFontSize = fileContentsS[15]
    strTitleFontSizeI = strTitleFontSize.find("|")+1
    strTitleFontSizeL = len(strTitleFontSize)
    strTitleFontSize = strTitleFontSize[strTitleFontSizeI:strTitleFontSizeL]
    global strTitleRatio
    strTitleRatio = fileContentsS[16]
    strTitleRatioI = strTitleRatio.find("|")+1
    strTitleRatioL = len(strTitleRatio)
    strTitleRatio = strTitleRatio[strTitleRatioI:strTitleRatioL]
    global strTitleTextAlign
    strTitleTextAlign = fileContentsS[17]
    strTitleTextAlignI = strTitleTextAlign.find("|")+1
    strTitleTextAlignL = len(strTitleTextAlign)
    strTitleTextAlign = strTitleTextAlign[strTitleTextAlignI:strTitleTextAlignL]
    global strTitleStyle
    strTitleStyle = fileContentsS[18]
    strTitleStyleI = strTitleStyle.find("|")+1
    strTitleStyleL = len(strTitleStyle)
    strTitleStyle = strTitleStyle[strTitleStyleI:strTitleStyleL] 
    global strDateInclude
    strDateInclude = fileContentsS[19]
    strDateIncludeI = strDateInclude.find("|")+1
    strDateIncludeL = len(strDateInclude)
    strDateInclude = strDateInclude[strDateIncludeI:strDateIncludeL]
    global strDateIncludeP
    strDateIncludeP = strDateInclude
    global strDateFont
    strDateFont = fileContentsS[20]
    strDateFontI = strDateFont.find("|")+1
    strDateFontL = len(strDateFont)
    strDateFont = strDateFont[strDateFontI:strDateFontL]
    global strDateFontSize
    strDateFontSize = fileContentsS[21]
    strDateFontSizeI = strDateFontSize.find("|")+1
    strDateFontSizeL = len(strDateFontSize)
    strDateFontSize = strDateFontSize[strDateFontSizeI:strDateFontSizeL]
    global strDateRatio
    strDateRatio = fileContentsS[22]
    strDateRatioI = strDateRatio.find("|")+1
    strDateRatioL = len(strDateRatio)
    strDateRatio = strDateRatio[strDateRatioI:strDateRatioL]
    global strDateTextAlign
    strDateTextAlign = fileContentsS[23]
    strDateTextAlignI = strDateTextAlign.find("|")+1
    strDateTextAlignL = len(strDateTextAlign)
    strDateTextAlign = strDateTextAlign[strDateTextAlignI:strDateTextAlignL]
    global strDateStyle
    strDateStyle = fileContentsS[24]
    strDateStyleI = strDateStyle.find("|")+1
    strDateStyleL = len(strDateStyle)
    strDateStyle = strDateStyle[strDateStyleI:strDateStyleL] 
    global strCatalogInclude
    strCatalogInclude = fileContentsS[25]
    strCatalogIncludeI = strCatalogInclude.find("|")+1
    strCatalogIncludeL = len(strCatalogInclude)
    strCatalogInclude = strCatalogInclude[strCatalogIncludeI:strCatalogIncludeL]
    global strCatalogIncludeP
    strCatalogIncludeP = strCatalogInclude
    global strCatalogFont
    strCatalogFont = fileContentsS[26]
    strCatalogFontI = strCatalogFont.find("|")+1
    strCatalogFontL = len(strCatalogFont)
    strCatalogFont = strCatalogFont[strCatalogFontI:strCatalogFontL]
    global strCatalogFontSize
    strCatalogFontSize = fileContentsS[27]
    strCatalogFontSizeI = strCatalogFontSize.find("|")+1
    strCatalogFontSizeL = len(strCatalogFontSize)
    strCatalogFontSize = strCatalogFontSize[strCatalogFontSizeI:strCatalogFontSizeL]
    global strCatalogRatio
    strCatalogRatio = fileContentsS[28]
    strCatalogRatioI = strCatalogRatio.find("|")+1
    strCatalogRatioL = len(strCatalogRatio)
    strCatalogRatio = strCatalogRatio[strCatalogRatioI:strCatalogRatioL]
    global strCatalogTextAlign
    strCatalogTextAlign = fileContentsS[29]
    strCatalogTextAlignI = strCatalogTextAlign.find("|")+1
    strCatalogTextAlignL = len(strCatalogTextAlign)
    strCatalogTextAlign = strCatalogTextAlign[strCatalogTextAlignI:strCatalogTextAlignL]
    global strCatalogStyle
    strCatalogStyle = fileContentsS[30]
    strCatalogStyleI = strCatalogStyle.find("|")+1
    strCatalogStyleL = len(strCatalogStyle)
    strCatalogStyle = strCatalogStyle[strCatalogStyleI:strCatalogStyleL] 
    global strCaptionInclude
    strCaptionInclude = fileContentsS[31]
    strCaptionIncludeI = strCaptionInclude.find("|")+1
    strCaptionIncludeL = len(strCaptionInclude)
    strCaptionInclude = strCaptionInclude[strCaptionIncludeI:strCaptionIncludeL]
    global strCaptionIncludeP
    strCaptionIncludeP = strCaptionInclude
    global strCaptionIncludeXP
    strCaptionIncludeXP = strCaptionInclude
    global strCaptionFont
    strCaptionFont = fileContentsS[32]
    strCaptionFontI = strCaptionFont.find("|")+1
    strCaptionFontL = len(strCaptionFont)
    strCaptionFont = strCaptionFont[strCaptionFontI:strCaptionFontL]
    global strCaptionFontSize
    strCaptionFontSize = fileContentsS[33]
    strCaptionFontSizeI = strCaptionFontSize.find("|")+1
    strCaptionFontSizeL = len(strCaptionFontSize)
    strCaptionFontSize = strCaptionFontSize[strCaptionFontSizeI:strCaptionFontSizeL]
    global strCaptionRatio
    strCaptionRatio = fileContentsS[34]
    strCaptionRatioI = strCaptionRatio.find("|")+1
    strCaptionRatioL = len(strCaptionRatio)
    strCaptionRatio = strCaptionRatio[strCaptionRatioI:strCaptionRatioL]
    global strCaptionTextAlign
    strCaptionTextAlign = fileContentsS[35]
    strCaptionTextAlignI = strCaptionTextAlign.find("|")+1
    strCaptionTextAlignL = len(strCaptionTextAlign)
    strCaptionTextAlign = strCaptionTextAlign[strCaptionTextAlignI:strCaptionTextAlignL]
    global strCaptionStyle
    strCaptionStyle = fileContentsS[36]
    strCaptionStyleI = strCaptionStyle.find("|")+1
    strCaptionStyleL = len(strCaptionStyle)
    strCaptionStyle = strCaptionStyle[strCaptionStyleI:strCaptionStyleL] 
    global strPhotoInclude
    strPhotoInclude = fileContentsS[37]
    strPhotoIncludeI = strPhotoInclude.find("|")+1
    strPhotoIncludeL = len(strPhotoInclude)
    strPhotoInclude = strPhotoInclude[strPhotoIncludeI:strPhotoIncludeL]
    global strPhotoIncludeP
    strPhotoIncludeP = strPhotoInclude
    global strPhotoGreyscale
    strPhotoGreyscale = fileContentsS[38]
    strPhotoGreyscaleI = strPhotoGreyscale.find("|")+1
    strPhotoGreyscaleL = len(strPhotoGreyscale)
    strPhotoGreyscale = strPhotoGreyscale[strPhotoGreyscaleI:strPhotoGreyscaleL]
    global strPhotoRatio
    strPhotoRatio = fileContentsS[39]
    strPhotoRatioI = strPhotoRatio.find("|")+1
    strPhotoRatioL = len(strPhotoRatio)
    strPhotoRatio = strPhotoRatio[strPhotoRatioI:strPhotoRatioL]
    global strLayoutTitle
    strLayoutTitle = fileContentsS[40]
    strLayoutTitleI = strLayoutTitle.find("|")+1
    strLayoutTitleL = len(strLayoutTitle)
    strLayoutTitle = strLayoutTitle[strLayoutTitleI:strLayoutTitleL]
    global strLayoutDate
    strLayoutDate = fileContentsS[41]
    strLayoutDateI = strLayoutDate.find("|")+1
    strLayoutDateL = len(strLayoutDate)
    strLayoutDate = strLayoutDate[strLayoutDateI:strLayoutDateL]
    global strLayoutCatalog
    strLayoutCatalog = fileContentsS[42]
    strLayoutCatalogI = strLayoutCatalog.find("|")+1
    strLayoutCatalogL = len(strLayoutCatalog)
    strLayoutCatalog = strLayoutCatalog[strLayoutCatalogI:strLayoutCatalogL]
    global strLayoutCaption
    strLayoutCaption = fileContentsS[43]
    strLayoutCaptionI = strLayoutCaption.find("|")+1
    strLayoutCaptionL = len(strLayoutCaption)
    strLayoutCaption = strLayoutCaption[strLayoutCaptionI:strLayoutCaptionL] 
    
    '''Convert text alignments to numeric codes'''
    global strTitleTextAlignN
    if strTitleTextAlign == 'Left':
        strTitleTextAlignN = 0
    elif strTitleTextAlign == 'Center':
        strTitleTextAlignN = 1
    elif strTitleTextAlign == 'Right':
        strTitleTextAlignN = 2
    elif strTitleTextAlign == 'Justified':
        strTitleTextAlignN = 3

    global strDateTextAlignN
    if strDateTextAlign == 'Left':
        strDateTextAlignN = 0
    elif strDateTextAlign == 'Center':
        strDateTextAlignN = 1
    elif strDateTextAlign == 'Right':
        strDateTextAlignN = 2
    elif strDateTextAlign == 'Justified':
        strDateTextAlignN = 3
        
    global strCatalogTextAlignN
    if strCatalogTextAlign == 'Left':
        strCatalogTextAlignN = 0
    elif strCatalogTextAlign == 'Center':
        strCatalogTextAlignN = 1
    elif strCatalogTextAlign == 'Right':
        strCatalogTextAlignN = 2
    elif strCatalogTextAlign == 'Justified':
        strCatalogTextAlignN = 3
        
    global strCaptionTextAlignN
    if strCaptionTextAlign == 'Left':
        strCaptionTextAlignN = 0
    elif strCaptionTextAlign == 'Center':
        strCaptionTextAlignN = 1
    elif strCaptionTextAlign == 'Right':
        strCaptionTextAlignN = 2
    elif strCaptionTextAlign == 'Justified':
        strCaptionTextAlignN = 3    

    '''Set global text box styles'''
    if strTitleStyle == 'Global':
        scribus.createCharStyle("styTitleC",strTitleFont,float(strTitleFontSize))
        scribus.createParagraphStyle("Title",1,float(strTitleFontSize),strTitleTextAlignN,0,0,0,0,0,0,0,0,"styTitleC")
    if strDateStyle == 'Global':
        scribus.createCharStyle("styDateC",strDateFont,float(strDateFontSize))
        scribus.createParagraphStyle("Date",1,float(strDateFontSize),strDateTextAlignN,0,0,0,0,0,0,0,0,"styDateC")
    if strCatalogStyle == 'Global':
        scribus.createCharStyle("styCatalogC",strCatalogFont,float(strCatalogFontSize))
        scribus.createParagraphStyle("Catalog",1,float(strCatalogFontSize),strCatalogTextAlignN,0,0,0,0,0,0,0,0,"styCatalogC")
    if strCaptionStyle == 'Global':
        scribus.createCharStyle("styCaptionC",strCaptionFont,float(strCaptionFontSize))
        scribus.createParagraphStyle("Caption",1,float(strCaptionFontSize),strCaptionTextAlignN,0,0,0,0,0,0,0,0,"styCaptionC")     
    
    '''Set global value to convert from millimeters to points'''
    global decConversionValue
    decConversionValue = float(2.83464657)
    
    '''Convert margin sizes from millimeters to points'''
    global strMarginTop
    strMarginTop = (round(float(strMarginTop) * decConversionValue,4))
    global strMarginBottom
    strMarginBottom = (round(float(strMarginBottom) * decConversionValue,4))
    global strMarginRight
    strMarginRight = (round(float(strMarginRight) * decConversionValue,4))
    global strMarginLeft
    strMarginLeft = (round(float(strMarginLeft) * decConversionValue,4))

    '''Convert padding from millimeters to points'''
    global strPaddingTop
    strPaddingTop = (round(float(strPaddingTop) * decConversionValue,4))
    global strPaddingLeft
    strPaddingLeft = (round(float(strPaddingLeft) * decConversionValue,4))
    
    '''Convert frame settings from millimeters to points'''
    global strFrameSpacing
    strFrameSpacing = (round(float(strFrameSpacing) * decConversionValue,4))
    global strFrameThicknessOuter
    strFrameThicknessOuter = (round(float(strFrameThicknessOuter),4))
    global strFrameThicknessInner
    strFrameThicknessInner = (round(float(strFrameThicknessInner),4))
    
    '''Calculate photo ratio'''
    global strPhotoRatio
    strPhotoRatio = (round(float(strPhotoRatio) / 100,4))
    
    '''Convert spacing from millimeters to points'''
    global strVerticalSpacing
    strVerticalSpacing = (round(float(strVerticalSpacing) * decConversionValue,4))
    global strOISpacing
    strOISpacing = (round(float(strOISpacing) * decConversionValue,4))
        
    '''Adjust includes based on style'''
    if strStyle == 'Inside':
        global strTitleInclude
        strTitleInclude = 'FALSE'
        global strTitleIncludeP
        strTitleIncludeP = strTitleInclude
        global strDateInclude
        strDateInclude = 'FALSE'
        global strDateIncludeP
        strDateIncludeP = strDateInclude
        global strCaptionInclude
        strCaptionInclude = 'FALSE'
        global strCaptionIncludeP
        strCaptionIncludeP = strCaptionInclude
        global strPhotoInclude
        strPhotoInclude = 'FALSE'
        global strPhotoIncludeP
        strPhotoIncludeP = strPhotoInclude
        global strCatalogIncludeX
        strCatalogIncludeX = 'FALSE'
        global strCatalogIncludeXP
        strCatalogIncludeXP = 'FALSE'
    elif strStyle == 'Outside/Inside':
        if strCatalogInclude == 'TRUE':
            global strCatalogInclude
            strCatalogInclude = 'FALSE'
            global strCatalogIncludeP
            strCatalogIncludeP = strCatalogInclude
            global strCatalogIncludeX
            strCatalogIncludeX = 'TRUE'
            global strCatalogIncludeXP
            strCatalogIncludeXP = strCatalogIncludeX
        else:
            global strCatalogIncludeX
            strCatalogIncludeX = 'FALSE'     
            global strCatalogIncludeXP
            strCatalogIncludeXP = strCatalogIncludeX
    else:
        global strCatalogIncludeX
        strCatalogIncludeX = 'FALSE'
        global strCatalogIncludeXP
        strCatalogIncludeXP = 'FALSE'

    funcImportBatch()

def funcImportBatch():
    '''Load data from the text file'''
    fileHandleB = open(strFileB, 'r')
    fileContentsB = fileHandleB.readlines()
    fileNumLines = len([l for l in fileContentsB if l.strip(' \n') != ''])
    fileHandleB.close
        
    '''Loop through the stamp entries and extract the respective field values from each entry'''
    icnt = 0
    while icnt < (fileNumLines):
        scribus.setUnit(0)
        fileHandleB = open(strFileB, 'r')
        fileLine = fileHandleB.readlines()
        strLineTemp = fileLine[icnt]
        strLineTemp = strLineTemp.replace("~", '\n')
        
        strLineTempI = strLineTemp.find("|")
        global strStampHeight
        strStampHeight = strLineTemp[0:strLineTempI]
        '''if StampHeight was left empty, assign a minimal value'''       
        if strStampHeight == 'NullField':
            strStampHeight = "5"
        else:
            strStampHeight = strStampHeight

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strStampWidth
        strStampWidth = strLineTemp[strLineTempM:strLineTempI]
        '''if StampWidth was left empty, assign a minimal value''' 
        if strStampWidth == 'NullField':
            strStampWidth = "5"
        else:
            strStampWidth = strStampWidth

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strTitle
        strTitle = strLineTemp[strLineTempM:strLineTempI]
        '''if Title was left empty, tell script to omit Title text box''' 
        global strTitleInclude    
        strTitleInclude = strTitleIncludeP
        if strTitle == 'NullField':
            if strTitleInclude == 'TRUE':
                strTitleInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strDate
        strDate = strLineTemp[strLineTempM:strLineTempI]
        '''if Date was left empty, tell script to omit Date text box'''         
        global strDateInclude
        strDateInclude = strDateIncludeP
        if strDate == 'NullField':
            if strDateInclude == 'TRUE':
                strDateInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strCatalog
        strCatalog = strLineTemp[strLineTempM:strLineTempI]
        '''if Catalog was left empty, tell script to omit Catalog text box''' 
        if strStyle == 'Outside/Inside':
            global strCatalogIncludeX
            strCatalogIncludeX = strCatalogIncludeXP
            if strCatalog == 'NullField':
                if strCatalogIncludeX == 'TRUE':
                    strCatalogIncludeX = 'FALSE'
        else:
            global strCatalogInclude
            strCatalogInclude = strCatalogIncludeP
            if strCatalog == 'NullField':
                if strCatalogInclude == 'TRUE':
                    strCatalogInclude = 'FALSE'
                
        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strCaption
        strCaption = strLineTemp[strLineTempM:strLineTempI]
        '''if Caption was left empty, tell script to omit Caption text box''' 
        global strCaptionInclude
        strCaptionInclude = strCaptionIncludeP
        if strCaption == 'NullField':
            if strCaptionInclude == 'TRUE':
                strCaptionInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strPhoto
        strPhoto = strLineTemp[strLineTempM:strLineTempI]
        '''if Photo was left empty, tell script to omit the Photo''' 
        global strPhotoInclude
        strPhotoInclude = strPhotoIncludeP
        if strPhoto == 'NullField':
            if strPhotoInclude == 'TRUE':
                strPhotoInclude = 'FALSE'
        
        '''call the Generate code'''
        funcGenerate()
        
        '''loop to the next stamp entry'''
        global icnt
        icnt = icnt + 1
        scribus.setUnit(origUnit)    
        fileHandleB.close()

def funcGenerate():
    '''Convert stamp width and height from millimeters to points'''
    global strStampHeight
    strStampHeight = (round(float(strStampHeight) * decConversionValue,4))
    global strStampWidth
    strStampWidth = (round(float(strStampWidth) * decConversionValue,4))

    '''Calculate frame dimensions'''
    global strFrameInnerHeight
    strFrameInnerHeight = (round(float(strStampHeight + (strPaddingTop * 2) + (strFrameThicknessInner * 2)),4))
    global strFrameInnerWidth
    strFrameInnerWidth = (round(float(strStampWidth + (strPaddingLeft * 2) + (strFrameThicknessInner * 2)),4))
    global strFrameOuterHeight
    strFrameOuterHeight = (round(float(strStampHeight + (strPaddingTop * 2) + (strFrameSpacing * 2) + (strFrameThicknessInner * 2) + (strFrameThicknessOuter * 2)),4))
    global strFrameOuterWidth
    strFrameOuterWidth = (round(float(strStampWidth + (strPaddingLeft * 2) + (strFrameSpacing * 2) + (strFrameThicknessInner * 2) + (strFrameThicknessOuter * 2)),4))

    '''Set default placement to page center'''
    pageWidth, pageHeight = scribus.getPageSize()
    topMargin, leftMargin, rightMargin, bottomMargin = scribus.getPageMargins()
        
    printAreaWidth  = pageWidth  - leftMargin - rightMargin
    printAreaHeight = pageHeight - topMargin  - bottomMargin 
    
    global strPlacementX
    strPlacementX = (round(float((printAreaWidth - strFrameOuterWidth)/2 + leftMargin),4))
    global strPlacementY
    strPlacementY = (round(float((printAreaHeight - strFrameOuterHeight)/2 + topMargin),4))

    '''Calculate photo dimensions'''
    global strPhotoHeight
    strPhotoHeight = (round(strStampHeight * strPhotoRatio,4))
    global strPhotoWidth
    strPhotoWidth = (round(strStampWidth * strPhotoRatio,4)) 
    
    '''Draw the frame'''
    if strFrameDouble == 'TRUE':
        global shpShapeNameFo
        shpShapeNameFo = scribus.createRect(strPlacementX, strPlacementY, strFrameOuterWidth, strFrameOuterHeight)
        scribus.setLineWidth(strFrameThicknessOuter, shpShapeNameFo)
        global shpShapeNameFi
        shpShapeNameFi = scribus.createRect(strPlacementX, strPlacementY, strFrameInnerWidth, strFrameInnerHeight)
        scribus.setLineWidth(strFrameThicknessInner, shpShapeNameFi)
        tmpFrameAlignOffsetX = (strFrameOuterWidth - strFrameInnerWidth) / 2
        scribus.setProperty(shpShapeNameFi, "xPos", scribus.getProperty(shpShapeNameFi, "xPos") + tmpFrameAlignOffsetX)
        tmpFrameAlignOffsetY = (strFrameOuterHeight - strFrameInnerHeight) / 2
        scribus.setProperty(shpShapeNameFi, "yPos", scribus.getProperty(shpShapeNameFi, "yPos") + tmpFrameAlignOffsetY)
    else:
        global shpShapeNameFo
        shpShapeNameFo = scribus.createRect(strPlacementX, strPlacementY, strFrameOuterWidth, strFrameOuterHeight)
        scribus.setLineWidth(strFrameThicknessOuter, shpShapeNameFo)
        global shpShapeNameFi
        shpShapeNameFi = shpShapeNameFo
    
    '''Add the photo'''
    if strPhotoInclude == 'TRUE':
        shpShapeNameP = scribus.createImage(strPlacementX, strPlacementY, strPhotoWidth, strPhotoHeight)
        tmpPhotoAlignOffsetX = (strFrameOuterWidth - strPhotoWidth) / 2
        scribus.setProperty(shpShapeNameP, "xPos", scribus.getProperty(shpShapeNameP, "xPos") + tmpPhotoAlignOffsetX)
        tmpPhotoAlignOffsetY = (strFrameOuterHeight - strPhotoHeight) / 2
        scribus.setProperty(shpShapeNameP, "yPos", scribus.getProperty(shpShapeNameP, "yPos") + tmpPhotoAlignOffsetY)
        scribus.loadImage(strPhoto, shpShapeNameP)        
        scribus.setScaleImageToFrame(True, True, shpShapeNameP)
        '''if strPhotoGreyscale.startswith('TRUE'):'''       
    else:
        global shpShapeNameP
        shpShapeNameP = shpShapeNameFo   
    
    '''Redefine variables for potentially omitted elements to avoid grouping errors'''
    global shpShapeNameT
    shpShapeNameT = shpShapeNameFo
    global shpShapeNameD
    shpShapeNameD = shpShapeNameFo
    global shpShapeNameCat
    shpShapeNameCat = shpShapeNameFo
    global shpShapeNameCap
    shpShapeNameCap = shpShapeNameFo         
    
    '''Cue the text boxes'''
    if strTitleInclude == 'TRUE':
        if strLayoutTitle == 'Top':
            funcTitleTop()
        elif strLayoutTitle == 'Right':
            funcTitleRight()
        elif strLayoutTitle == 'Bottom':
            funcTitleBottom()
        elif strLayoutTitle == 'Left':
            funcTitleLeft()
    else:
        if strDateInclude == 'TRUE':
            if strLayoutDate == 'Top':
                funcDateTop()
            elif strLayoutDate == 'Right':
                funcDateRight()
            elif strLayoutDate == 'Bottom':
                funcDateBottom()
            elif strLayoutDate == 'Left':
                funcDateLeft()
        else:   
            if strCatalogInclude == 'TRUE':
                if strStyle == 'Inside':
                    funcCatalogCenter()
                elif strLayoutCatalog == 'Top':
                    funcCatalogTop()
                elif strLayoutCatalog == 'Right':
                    funcCatalogRight()
                elif strLayoutCatalog == 'Bottom':
                    funcCatalogBottom()
                elif strLayoutCatalog == 'Left':
                    funcCatalogLeft()
            elif strCatalogIncludeX == 'TRUE':
                if strStyle == 'Outside/Inside':
                    funCatalogCenter()
            else:    
                if strCaptionInclude == 'TRUE':
                    if strLayoutCaption == 'Top':
                        funcCaptionTop()
                    elif strLayoutCaption == 'Right':
                        funcCaptionRight()
                    elif strLayoutCaption == 'Bottom':
                        funcCaptionBottom()
                    elif strLayoutCaption == 'Left':
                        funcCaptionLeft()
    
    funcCenterMiddles()
    funcGroupAndAlign()
    scribus.setUnit(origUnit)

def funcTitleTop():
    if strCaptionInclude == 'TRUE':
        if strLayoutCaption == 'Top':
            funcCaptionTop()
        elif strLayoutCaption == 'Right':
            funcCaptionRight()
        elif strLayoutCaption == 'Bottom':
            funcCaptionBottom()
        elif strLayoutCaption == 'Left':
            funcCaptionLeft()

    if strCatalogInclude == 'TRUE':
        if strStyle == 'Inside':
            funcCatalogCenter()
        elif strLayoutCatalog == 'Top':
            funcCatalogTop()
        elif strLayoutCatalog == 'Right':
            funcCatalogRight()
        elif strLayoutCatalog == 'Bottom':
            funcCatalogBottom()
        elif strLayoutCatalog == 'Left':
            funcCatalogLeft()
    elif strCatalogIncludeX == 'TRUE':
        if strStyle == 'Outside/Inside':
            funcCatalogCenter()

    if strDateInclude == 'TRUE':
        if strLayoutDate == 'Top':
            funcDateTop()
        elif strLayoutDate == 'Right':
            funcDateRight()
        elif strLayoutDate == 'Bottom':
            funcDateBottom()
        elif strLayoutDate == 'Left':
            funcDateLeft()
            
    strTitleWidth = (round(float(strFrameOuterWidth) * float(strTitleRatio) / 100, 4))
    strTitleHeight = float(10)
    strTitleShift = (round(float(strTitleWidth - strFrameOuterWidth) / 2, 4))
    strTitleLeft = (round(float(strPlacementX - strTitleShift), 4))
    global shpShapeNameT
    shpShapeNameT = scribus.createText(strTitleLeft, strPlacementY, strTitleWidth, strTitleHeight)
    
    scribus.setText(strTitle, shpShapeNameT)
    if strTitleStyle == 'Global':
        TextLengthT = scribus.getTextLength(shpShapeNameT)
        scribus.selectText(0,TextLengthT,shpShapeNameT)
        scribus.setStyle("Title",shpShapeNameT)
    else:
        scribus.setFont(strTitleFont, shpShapeNameT)
        scribus.setFontSize(float(strTitleFontSize), shpShapeNameT)
        if strTitleTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameT)
        elif strTitleTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameT)
        elif strTitleTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameT)
        elif strTitleTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameT)    
        scribus.setLineSpacing(float(strTitleFontSize)*float(1.15), shpShapeNameT)
    
    (Tw, Th) = scribus.getSize(shpShapeNameT)
    while (((scribus.textOverflows(shpShapeNameT) == 0)) and (Th > 0)) :
        Th -= 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    while ((scribus.textOverflows(shpShapeNameT) > 0)) :
        Th += 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    global strTitleHeight
    strTitleHeight = Th


def funcTitleRight():
    strTitleWidth = (round(float(strFrameOuterWidth) * float(strTitleRatio) / 100, 4))
    strTitleHeight = float(10)
    strTitleLeft = (round(float(strPlacementX + strFrameOuterWidth + strMarginRight), 4))
    global shpShapeNameT
    shpShapeNameT = scribus.createText(strTitleLeft, strPlacementY, strTitleWidth, strTitleHeight)
    
    scribus.setText(strTitle, shpShapeNameT)
    if strTitleStyle == 'Global':
        TextLengthT = scribus.getTextLength(shpShapeNameT)
        scribus.selectText(0,TextLengthT,shpShapeNameT)
        scribus.setStyle("Title",shpShapeNameT)
    else:
        scribus.setFont(strTitleFont, shpShapeNameT)
        scribus.setFontSize(float(strTitleFontSize), shpShapeNameT)
        if strTitleTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameT)
        elif strTitleTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameT)
        elif strTitleTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameT)
        elif strTitleTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameT)    
        scribus.setLineSpacing(float(strTitleFontSize)*float(1.15), shpShapeNameT)
    
    (Tw, Th) = scribus.getSize(shpShapeNameT)
    while (((scribus.textOverflows(shpShapeNameT) == 0)) and (Th > 0)) :
        Th -= 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    while ((scribus.textOverflows(shpShapeNameT) > 0)) :
        Th += 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    global strTitleHeight
    strTitleHeight = Th
    
    if strDateInclude == 'TRUE':
        if strLayoutDate == 'Top':
            funcDateTop()
        elif strLayoutDate == 'Right':
            funcDateRight()
        elif strLayoutDate == 'Bottom':
            funcDateBottom()
        elif strLayoutDate == 'Left':
            funcDateLeft()

    if strCatalogInclude == 'TRUE':
        if strStyle == 'Inside':
            funcCatalogCenter()
        elif strLayoutCatalog == 'Top':
            funcCatalogTop()
        elif strLayoutCatalog == 'Right':
            funcCatalogRight()
        elif strLayoutCatalog == 'Bottom':
            funcCatalogBottom()
        elif strLayoutCatalog == 'Left':
            funcCatalogLeft()
    elif strCatalogIncludeX == 'TRUE':
        if strStyle == 'Outside/Inside':
            funcCatalogCenter()
        
    if strCaptionInclude == 'TRUE':
        if strLayoutCaption == 'Top':
            funcCaptionTop()
        elif strLayoutCaption == 'Right':
            funcCaptionRight()
        elif strLayoutCaption == 'Bottom':
            funcCaptionBottom()
        elif strLayoutCaption == 'Left':
            funcCaptionLeft()

def funcTitleBottom():
    strTitleWidth = (round(float(strFrameOuterWidth) * float(strTitleRatio) / 100, 4))
    strTitleHeight = float(10)
    strTitleShift = (round(float(strTitleWidth - strFrameOuterWidth) / 2, 4))
    strTitleLeft = (round(float(strPlacementX - strTitleShift), 4))
    global shpShapeNameT
    shpShapeNameT = scribus.createText(strTitleLeft, strPlacementY, strTitleWidth, strTitleHeight)
    
    scribus.setText(strTitle, shpShapeNameT)
    if strTitleStyle == 'Global':
        TextLengthT = scribus.getTextLength(shpShapeNameT)
        scribus.selectText(0,TextLengthT,shpShapeNameT)
        scribus.setStyle("Title",shpShapeNameT)
    else:
        scribus.setFont(strTitleFont, shpShapeNameT)
        scribus.setFontSize(float(strTitleFontSize), shpShapeNameT)
        if strTitleTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameT)
        elif strTitleTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameT)
        elif strTitleTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameT)
        elif strTitleTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameT)    
        scribus.setLineSpacing(float(strTitleFontSize)*float(1.15), shpShapeNameT)
    
    (Tw, Th) = scribus.getSize(shpShapeNameT)
    while (((scribus.textOverflows(shpShapeNameT) == 0)) and (Th > 0)) :
        Th -= 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    while ((scribus.textOverflows(shpShapeNameT) > 0)) :
        Th += 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    global strTitleHeight
    strTitleHeight = Th
    
    if strDateInclude == 'TRUE':
        if strLayoutDate == 'Top':
            funcDateTop()
        elif strLayoutDate == 'Right':
            funcDateRight()
        elif strLayoutDate == 'Bottom':
            funcDateBottom()
        elif strLayoutDate == 'Left':
            funcDateLeft()
        
    if strCatalogInclude == 'TRUE':
        if strStyle == 'Inside':
            funcCatalogCenter()         
        elif strLayoutCatalog == 'Top':
            funcCatalogTop()
        elif strLayoutCatalog == 'Right':
            funcCatalogRight()
        elif strLayoutCatalog == 'Bottom':
            funcCatalogBottom()
        elif strLayoutCatalog == 'Left':
            funcCatalogLeft()
    elif strCatalogIncludeX == 'TRUE':
        if strStyle == 'Outside/Inside':
            funcCatalogCenter()
        
    if strCaptionInclude == 'TRUE':
        if strLayoutCaption == 'Top':
            funcCaptionTop()
        elif strLayoutCaption == 'Right':
            funcCaptionRight()
        elif strLayoutCaption == 'Bottom':
            funcCaptionBottom()
        elif strLayoutCaption == 'Left':
            funcCaptionLeft()

def funcTitleLeft():
    strTitleWidth = (round(float(strFrameOuterWidth) * float(strTitleRatio) / 100, 4))
    strTitleHeight = float(10)
    strTitleLeft = (round(float(strPlacementX - strMarginLeft - strTitleWidth), 4))
    global shpShapeNameT
    shpShapeNameT = scribus.createText(strTitleLeft, strPlacementY, strTitleWidth, strTitleHeight)
    
    scribus.setText(strTitle, shpShapeNameT)
    if strTitleStyle == 'Global':
        TextLengthT = scribus.getTextLength(shpShapeNameT)
        scribus.selectText(0,TextLengthT,shpShapeNameT)
        scribus.setStyle("Title",shpShapeNameT)
    else:
        scribus.setFont(strTitleFont, shpShapeNameT)
        scribus.setFontSize(float(strTitleFontSize), shpShapeNameT)
        if strTitleTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameT)
        elif strTitleTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameT)
        elif strTitleTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameT)
        elif strTitleTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameT)    
        scribus.setLineSpacing(float(strTitleFontSize)*float(1.15), shpShapeNameT)
    
    (Tw, Th) = scribus.getSize(shpShapeNameT)
    while (((scribus.textOverflows(shpShapeNameT) == 0)) and (Th > 0)) :
        Th -= 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    while ((scribus.textOverflows(shpShapeNameT) > 0)) :
        Th += 1
        scribus.sizeObject(Tw, Th, shpShapeNameT)
    global strTitleHeight
    strTitleHeight = Th
    
    if strDateInclude == 'TRUE':
        if strLayoutDate == 'Top':
            funcDateTop()
        elif strLayoutDate == 'Right':
            funcDateRight()
        elif strLayoutDate == 'Bottom':
            funcDateBottom()
        elif strLayoutDate == 'Left':
            funcDateLeft()

    if strCatalogInclude == 'TRUE':
        if strStyle == 'Inside':
            funcCatalogCenter()
        elif strLayoutCatalog == 'Top':
            funcCatalogTop()
        elif strLayoutCatalog == 'Right':
            funcCatalogRight()
        elif strLayoutCatalog == 'Bottom':
            funcCatalogBottom()
        elif strLayoutCatalog == 'Left':
            funcCatalogLeft()
    elif strCatalogIncludeX == 'TRUE':
        if strStyle == 'Outside/Inside':
            funcCatalogCenter()
        
    if strCaptionInclude == 'TRUE':
        if strLayoutCaption == 'Top':
            funcCaptionTop()
        elif strLayoutCaption == 'Right':
            funcCaptionRight()
        elif strLayoutCaption == 'Bottom':
            funcCaptionBottom()
        elif strLayoutCaption == 'Left':
            funcCaptionLeft()

def funcTitlePlacement():
    if strTitleInclude == 'TRUE':
        if strLayoutTitle == 'Top':
            if strCaptionInclude == 'TRUE':
                if strLayoutCaption == 'Top':
                    if strCatalogInclude == 'TRUE':
                        if strLayoutCatalog == 'Top':
                            if strDateInclude == 'TRUE':
                                if strLayoutDate == 'Top':
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY - 
                                    strMarginTop - strTitleHeight - strDateHeight - 
                                    strCatalogHeight - strCaptionHeight - 
                                    (strVerticalSpacing * 3)),4))
                                else:
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY - 
                                    strMarginTop - strTitleHeight - 
                                    strCatalogHeight - strCaptionHeight - 
                                    (strVerticalSpacing * 2)),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - 
                                strMarginTop - strTitleHeight - strCatalogHeight - 
                                strCaptionHeight - (strVerticalSpacing * 2)),4))
                        else:
                            if strDateInclude == 'TRUE':
                                if strLayoutDate == 'Top':
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY -
                                    strMarginTop - strTitleHeight - strDateHeight - 
                                    strCaptionHeight - (strVerticalSpacing * 2)),4))
                                else:
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY - 
                                    strMarginTop - strTitleHeight - strCaptionHeight - 
                                    strVerticalSpacing),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - strMarginTop - 
                                strTitleHeight - strCaptionHeight - strVerticalSpacing),4))
                    else:
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Top':
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY -
                                strMarginTop - strTitleHeight - strDateHeight - 
                                strCaptionHeight - (strVerticalSpacing * 2)),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - 
                                strMarginTop - strTitleHeight - strCaptionHeight - 
                                strVerticalSpacing),4))
                        else:
                            global strTitleTop
                            strTitleTop = (round(float(strPlacementY - strMarginTop - 
                            strTitleHeight - strCaptionHeight - strVerticalSpacing),4))
                else:
                    if strCatalogInclude == 'TRUE':
                        if strLayoutCatalog == 'Top':
                            if strDateInclude == 'TRUE':
                                if strLayoutDate == 'Top':
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY - 
                                    strMarginTop - strTitleHeight - strDateHeight - 
                                    strCatalogHeight - (strVerticalSpacing * 2)),4))
                                else:
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY - 
                                    strMarginTop - strTitleHeight - strCatalogHeight - 
                                    strVerticalSpacing),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - strMarginTop - 
                                strTitleHeight - strCatalogHeight - strVerticalSpacing),4))
                        else:
                            if strDateInclude == 'TRUE':
                                if strLayoutDate == 'Top':
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY - 
                                    strMarginTop - strTitleHeight - strDateHeight - 
                                    strVerticalSpacing),4))
                                else:
                                    global strTitleTop
                                    strTitleTop = (round(float(strPlacementY - 
                                    strMarginTop - strTitleHeight),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - 
                                strMarginTop - strTitleHeight),4))
                    else:
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Top':
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - 
                                strMarginTop - strTitleHeight - strDateHeight - 
                                strVerticalSpacing),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - 
                                strMarginTop - strTitleHeight),4))
                        else:
                            global strTitleTop
                            strTitleTop = (round(float(strPlacementY - 
                            strMarginTop - strTitleHeight),4))                
            else:
                if strCatalogInclude == 'TRUE':
                    if strLayoutCatalog == 'Top':
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Top':
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - strMarginTop - 
                                strTitleHeight - strDateHeight - strCatalogHeight - 
                                (strVerticalSpacing * 2)),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - strMarginTop - 
                                strTitleHeight - strCatalogHeight - strVerticalSpacing),4))
                        else:
                            global strTitleTop
                            strTitleTop = (round(float(strPlacementY - strMarginTop - 
                            strTitleHeight - strCatalogHeight - strVerticalSpacing),4))
                    else:
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Top':
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - strMarginTop - 
                                strTitleHeight - strDateHeight - strVerticalSpacing),4))
                            else:
                                global strTitleTop
                                strTitleTop = (round(float(strPlacementY - strMarginTop - 
                                strTitleHeight),4))
                        else:
                            global strTitleTop
                            strTitleTop = (round(float(strPlacementY - strMarginTop - 
                            strTitleHeight),4))                  
                else:
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Top':
                            global strTitleTop
                            strTitleTop = (round(float(strPlacementY - strMarginTop - 
                            strTitleHeight - strDateHeight - strVerticalSpacing),4))
                        else:
                            global strTitleTop
                            strTitleTop = (round(float(strPlacementY - strMarginTop - 
                            strTitleHeight),4))
                    else:
                        global strTitleTop
                        strTitleTop = (round(float(strPlacementY - strMarginTop - 
                        strTitleHeight),4))                           
        elif strLayoutTitle == 'Right':
            global strTitleTop
            strTitleTop = (round(float(strPlacementY + (strFrameOuterHeight - strRightOverallHeight) / 2),4))
        elif strLayoutTitle == 'Bottom':    
            global strTitleTop
            strTitleTop = (round(float(strPlacementY + strFrameOuterHeight + strMarginBottom),4))
        elif strLayoutTitle == 'Left':
            global strTitleTop
            strTitleTop = (round(float(strPlacementY + (strFrameOuterHeight - strLeftOverallHeight) / 2),4))
    
        strTitleOffset = strTitleTop - strPlacementY
        scribus.moveObject(0, strTitleOffset, shpShapeNameT)    
            
def funcDateTop():
    '''Check to see if the Title code has already placed the Caption and Catalog'''
    if strTitleInclude == 'FALSE':
        if strCaptionInclude == 'TRUE':
            if strLayoutCaption == 'Top':
                funcCaptionTop()
            elif strLayoutCaption == 'Right':
                funcCaptionRight()
            elif strLayoutCaption == 'Bottom':
                funcCaptionBottom()
            elif strLayoutCaption == 'Left':
                funcCaptionLeft()
  
        if strCatalogInclude == 'TRUE':
            if strStyle == 'Inside':
                funcCatalogCenter()               
            elif strLayoutCatalog == 'Top':
                funcCatalogTop()
            elif strLayoutCatalog == 'Right':
                funcCatalogRight()
            elif strLayoutCatalog == 'Bottom':
                funcCatalogBottom()
            elif strLayoutCatalog == 'Left':
                funcCatalogLeft()
        elif strCatalogIncludeX == 'TRUE':
            if strStyle == 'Outside/Inside':
                funcCatalogCenter()

    strDateWidth = (round(float(strFrameOuterWidth) * float(strDateRatio) / 100, 4))
    strDateHeight = float(10)
    strDateShift = (round(float(strDateWidth - strFrameOuterWidth) / 2, 4))
    strDateLeft = (round(float(strPlacementX - strDateShift), 4))
    global shpShapeNameD
    shpShapeNameD = scribus.createText(strDateLeft, strPlacementY, strDateWidth, strDateHeight)
    
    scribus.setText(strDate, shpShapeNameD)
    if strDateStyle == 'Global':
        TextLengthD = scribus.getTextLength(shpShapeNameD)
        scribus.selectText(0,TextLengthD,shpShapeNameD)
        scribus.setStyle("Date",shpShapeNameD)
    else:
        scribus.setFont(strDateFont, shpShapeNameD)
        scribus.setFontSize(float(strDateFontSize), shpShapeNameD)
        if strDateTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameD)
        elif strDateTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameD)
        elif strDateTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameD)
        elif strDateTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameD)    
        scribus.setLineSpacing(float(strDateFontSize)*float(1.15), shpShapeNameD)
    
    (Dw, Dh) = scribus.getSize(shpShapeNameD)
    while (((scribus.textOverflows(shpShapeNameD) == 0)) and (Dh > 0)) :
        Dh -= 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    while ((scribus.textOverflows(shpShapeNameD) > 0)) :
        Dh += 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    global strDateHeight
    strDateHeight = Dh

def funcDateRight():
    strDateWidth = (round(float(strFrameOuterWidth) * float(strDateRatio) / 100, 4))
    strDateHeight = float(10)
    strDateLeft = (round(float(strPlacementX + strFrameOuterWidth + strMarginRight), 4))
    global shpShapeNameD
    shpShapeNameD = scribus.createText(strDateLeft, strPlacementY, strDateWidth, strDateHeight)
    
    scribus.setText(strDate, shpShapeNameD)
    if strDateStyle == 'Global':
        TextLengthD = scribus.getTextLength(shpShapeNameD)
        scribus.selectText(0,TextLengthD,shpShapeNameD)
        scribus.setStyle("Date",shpShapeNameD)
    else:
        scribus.setFont(strDateFont, shpShapeNameD)
        scribus.setFontSize(float(strDateFontSize), shpShapeNameD)
        if strDateTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameD)
        elif strDateTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameD)
        elif strDateTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameD)
        elif strDateTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameD)    
        scribus.setLineSpacing(float(strDateFontSize)*float(1.15), shpShapeNameD)
    
    (Dw, Dh) = scribus.getSize(shpShapeNameD)
    while (((scribus.textOverflows(shpShapeNameD) == 0)) and (Dh > 0)) :
        Dh -= 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    while ((scribus.textOverflows(shpShapeNameD) > 0)) :
        Dh += 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    global strDateHeight
    strDateHeight = Dh

    '''Check to see if the Title code has already placed the Caption and Catalog'''
    if strTitleInclude == 'FALSE':
        if strCaptionInclude == 'TRUE':
            if strLayoutCaption == 'Top':
                funcCaptionTop()
            elif strLayoutCaption == 'Right':
                funcCaptionRight()
            elif strLayoutCaption == 'Bottom':
                funcCaptionBottom()
            elif strLayoutCaption == 'Left':
                funcCaptionLeft()
  
        if strCatalogInclude == 'TRUE':
            if strStyle == 'Inside':
                funcCatalogCenter()              
            elif strLayoutCatalog == 'Top':
                funcCatalogTop()
            elif strLayoutCatalog == 'Right':
                funcCatalogRight()
            elif strLayoutCatalog == 'Bottom':
                funcCatalogBottom()
            elif strLayoutCatalog == 'Left':
                funcCatalogLeft()
        elif strCatalogIncludeX == 'TRUE':
            if strStyle == 'Outside/Inside':
                funcCatalogCenter()

def funcDateBottom():
    strDateWidth = (round(float(strFrameOuterWidth) * float(strDateRatio) / 100, 4))
    strDateHeight = float(10)
    strDateShift = (round(float(strDateWidth - strFrameOuterWidth) / 2, 4))
    strDateLeft = (round(float(strPlacementX - strDateShift), 4))
    global shpShapeNameD
    shpShapeNameD = scribus.createText(strDateLeft, strPlacementY, strDateWidth, strDateHeight)
    
    scribus.setText(strDate, shpShapeNameD)
    if strDateStyle == 'Global':
        TextLengthD = scribus.getTextLength(shpShapeNameD)
        scribus.selectText(0,TextLengthD,shpShapeNameD)
        scribus.setStyle("Date",shpShapeNameD)
    else:
        scribus.setFont(strDateFont, shpShapeNameD)
        scribus.setFontSize(float(strDateFontSize), shpShapeNameD)
        if strDateTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameD)
        elif strDateTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameD)
        elif strDateTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameD)
        elif strDateTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameD)    
        scribus.setLineSpacing(float(strDateFontSize)*float(1.15), shpShapeNameD)
    
    (Dw, Dh) = scribus.getSize(shpShapeNameD)
    while (((scribus.textOverflows(shpShapeNameD) == 0)) and (Dh > 0)) :
        Dh -= 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    while ((scribus.textOverflows(shpShapeNameD) > 0)) :
        Dh += 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    global strDateHeight
    strDateHeight = Dh

    '''Check to see if the Title code has already placed the Caption and Catalog'''
    if strTitleInclude == 'FALSE':
        if strCaptionInclude == 'TRUE':
            if strLayoutCaption == 'Top':
                funcCaptionTop()
            elif strLayoutCaption == 'Right':
                funcCaptionRight()
            elif strLayoutCaption == 'Bottom':
                funcCaptionBottom()
            elif strLayoutCaption == 'Left':
                funcCaptionLeft()
  
        if strCatalogInclude == 'TRUE':
            if strStyle == 'Inside':
                funcCatalogCenter()
            elif strLayoutCatalog == 'Top':
                funcCatalogTop()
            elif strLayoutCatalog == 'Right':
                funcCatalogRight()
            elif strLayoutCatalog == 'Bottom':
                funcCatalogBottom()
            elif strLayoutCatalog == 'Left':
                funcCatalogLeft()
        elif strCatalogIncludeX == 'TRUE':
            if strStyle == 'Outside/Inside':
                funcCatalogCenter()

def funcDateLeft():
    strDateWidth = (round(float(strFrameOuterWidth) * float(strDateRatio) / 100, 4))
    strDateHeight = float(10)
    strDateLeft = (round(float(strPlacementX - strDateWidth - strMarginLeft), 4))
    global shpShapeNameD
    shpShapeNameD = scribus.createText(strDateLeft, strPlacementY, strDateWidth, strDateHeight)
    
    scribus.setText(strDate, shpShapeNameD)
    if strDateStyle == 'Global':
        TextLengthD = scribus.getTextLength(shpShapeNameD)
        scribus.selectText(0,TextLengthD,shpShapeNameD)
        scribus.setStyle("Date",shpShapeNameD)
    else:
        scribus.setFont(strDateFont, shpShapeNameD)
        scribus.setFontSize(float(strDateFontSize), shpShapeNameD)
        if strDateTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameD)
        elif strDateTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameD)
        elif strDateTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameD)
        elif strDateTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameD)    
        scribus.setLineSpacing(float(strDateFontSize)*float(1.15), shpShapeNameD)
    
    (Dw, Dh) = scribus.getSize(shpShapeNameD)
    while (((scribus.textOverflows(shpShapeNameD) == 0)) and (Dh > 0)) :
        Dh -= 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    while ((scribus.textOverflows(shpShapeNameD) > 0)) :
        Dh += 1
        scribus.sizeObject(Dw, Dh, shpShapeNameD)
    global strDateHeight
    strDateHeight = Dh

    '''Check to see if the Title code has already placed the Caption and Catalog'''
    if strTitleInclude == 'FALSE':
        if strCaptionInclude == 'TRUE':
            if strLayoutCaption == 'Top':
                funcCaptionTop()
            elif strLayoutCaption == 'Right':
                funcCaptionRight()
            elif strLayoutCaption == 'Bottom':
                funcCaptionBottom()
            elif strLayoutCaption == 'Left':
                funcCaptionLeft()
  
        if strCatalogInclude == 'TRUE':
            if strStyle == 'Inside':
                funcCatalogCenter()
            elif strLayoutCatalog == 'Top':
                funcCatalogTop()
            elif strLayoutCatalog == 'Right':
                funcCatalogRight()
            elif strLayoutCatalog == 'Bottom':
                funcCatalogBottom()
            elif strLayoutCatalog == 'Left':
                funcCatalogLeft()
        elif strCatalogIncludeX == 'TRUE':
            if strStyle == 'Outside/Inside':
                funcCatalogCenter()
 
def funcDatePlacement():
    if strDateInclude == 'TRUE':
        if strLayoutDate == 'Top':
            if strCaptionInclude == 'TRUE':
                if strLayoutCaption == 'Top':
                    if strCatalogInclude == 'TRUE':
                        if strLayoutCatalog == 'Top':
                            global strDateTop
                            strDateTop = (round(float(strPlacementY - strMarginTop - 
                            strDateHeight - strCatalogHeight - strCaptionHeight - 
                            (strVerticalSpacing * 2)),4))
                        else:
                            global strDateTop
                            strDateTop = (round(float(strPlacementY - strMarginTop - 
                            strDateHeight - strCaptionHeight - strVerticalSpacing),4))
                    else:
                        global strDateTop
                        strDateTop = (round(float(strPlacementY - strMarginTop - 
                        strDateHeight - strCaptionHeight - strVerticalSpacing),4))
                else:
                    if strCatalogInclude == 'TRUE':
                        if strLayoutCatalog == 'Top':
                            global strDateTop
                            strDateTop = (round(float(strPlacementY - strMarginTop - 
                            strDateHeight - strCatalogHeight - strVerticalSpacing),4))
                        else:
                            global strDateTop
                            strDateTop = (round(float(strPlacementY - strMarginTop - 
                            strDateHeight),4))
                    else:
                        global strDateTop
                        strDateTop = (round(float(strPlacementY - strMarginTop - strDateHeight),4))
            else:
                if strCatalogInclude == 'TRUE':
                    if strLayoutCatalog == 'Top':
                        global strDateTop
                        strDateTop = (round(float(strPlacementY - strMarginTop - 
                        strDateHeight - strCatalogHeight - strVerticalSpacing),4))
                    else:
                        global strDateTop
                        strDateTop = (round(float(strPlacementY - strMarginTop - 
                        strDateHeight),4))
                else:
                    global strDateTop
                    strDateTop = (round(float(strPlacementY - strMarginTop - strDateHeight),4))
        elif strLayoutDate == 'Right':
            if strTitleInclude == 'TRUE':
                if strLayoutTitle == 'Right':
                    global strDateTop
                    strDateTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                    strRightOverallHeight) / 2) + strRightTitleHeight + strVerticalSpacing),4))
                else:
                    global strDateTop
                    strDateTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                    strRightOverallHeight) / 2) + strRightTitleHeight),4))
            else:
                global strDateTop
                strDateTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                strRightOverallHeight) / 2) + strRightTitleHeight),4))
        elif strLayoutDate == 'Bottom':
            if strTitleInclude == 'TRUE':
                if strLayoutTitle == 'Bottom':
                    global strDateTop
                    strDateTop = (round(float(strPlacementY + strFrameOuterHeight +
                    strTitleHeight + strMarginBottom + strVerticalSpacing),4))
                else:
                    global strDateTop
                    strDateTop = (round(float(strPlacementY + strFrameOuterHeight +
                    strMarginBottom),4))
            else:
                global strDateTop
                strDateTop = (round(float(strPlacementY + strFrameOuterHeight +
                strMarginBottom),4))
        elif strLayoutDate == 'Left':
            if strTitleInclude == 'TRUE':
                if strLayoutTitle == 'Left':
                    global strDateTop
                    strDateTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                    strLeftOverallHeight) / 2) + strLeftTitleHeight + strVerticalSpacing),4))
                else:
                    global strDateTop
                    strDateTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                    strLeftOverallHeight) / 2) + strLeftTitleHeight),4))
            else:
                global strDateTop
                strDateTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                strLeftOverallHeight) / 2) + strLeftTitleHeight),4))
    
        strDateOffset = strDateTop - strPlacementY
        scribus.moveObject(0, strDateOffset, shpShapeNameD)  

def funcCatalogTop():
    '''Place the Caption, if not already placed'''
    if strTitleInclude == 'FALSE':
        if strDateInclude == 'FALSE':
            if strCaptionInclude == 'TRUE':
                if strLayoutCaption == 'Top':
                    funcCaptionTop()
                elif strLayoutCaption == 'Right':
                    funcCaptionRight()
                elif strLayoutCaption == 'Bottom':
                    funcCaptionBottom()
                elif strLayoutCaption == 'Left':
                    funcCaptionLeft()    
    
    strCatalogWidth = (round(float(strFrameOuterWidth) * float(strCatalogRatio) / 100, 4))
    strCatalogHeight = float(10)
    strCatalogShift = (round(float(strCatalogWidth - strFrameOuterWidth) / 2, 4))
    strCatalogLeft = (round(float(strPlacementX - strCatalogShift), 4))
    global shpShapeNameCat
    shpShapeNameCat = scribus.createText(strCatalogLeft, strPlacementY, strCatalogWidth, strCatalogHeight)
    
    scribus.setText(strCatalog, shpShapeNameCat) 
    if strCatalogStyle == 'Global':
        TextLengthCat = scribus.getTextLength(shpShapeNameCat)
        scribus.selectText(0,TextLengthCat,shpShapeNameCat)
        scribus.setStyle("Catalog",shpShapeNameCat)
    else:
        scribus.setFont(strCatalogFont, shpShapeNameCat)
        scribus.setFontSize(float(strCatalogFontSize), shpShapeNameCat)
        if strCatalogTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCat)
        elif strCatalogTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCat)
        elif strCatalogTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCat)
        elif strCatalogTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCat)    
        scribus.setLineSpacing(float(strCatalogFontSize)*float(1.15), shpShapeNameCat)
    
    (Catw, Cath) = scribus.getSize(shpShapeNameCat)
    while (((scribus.textOverflows(shpShapeNameCat) == 0)) and (Cath > 0)) :
        Cath -= 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    while ((scribus.textOverflows(shpShapeNameCat) > 0)) :
        Cath += 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    global strCatalogHeight
    strCatalogHeight = Cath
    
def funcCatalogRight():
    strCatalogWidth = (round(float(strFrameOuterWidth) * float(strCatalogRatio) / 100, 4))
    strCatalogHeight = float(10)
    strCatalogLeft = (round(float(strPlacementX + strFrameOuterWidth + strMarginRight), 4))
    global shpShapeNameCat
    shpShapeNameCat = scribus.createText(strCatalogLeft, strPlacementY, strCatalogWidth, strCatalogHeight)
    
    scribus.setText(strCatalog, shpShapeNameCat) 
    if strCatalogStyle == 'Global':
        TextLengthCat = scribus.getTextLength(shpShapeNameCat)
        scribus.selectText(0,TextLengthCat,shpShapeNameCat)
        scribus.setStyle("Catalog",shpShapeNameCat)
    else:
        scribus.setFont(strCatalogFont, shpShapeNameCat)
        scribus.setFontSize(float(strCatalogFontSize), shpShapeNameCat)
        if strCatalogTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCat)
        elif strCatalogTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCat)
        elif strCatalogTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCat)
        elif strCatalogTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCat)    
        scribus.setLineSpacing(float(strCatalogFontSize)*float(1.15), shpShapeNameCat)
    
    (Catw, Cath) = scribus.getSize(shpShapeNameCat)
    while (((scribus.textOverflows(shpShapeNameCat) == 0)) and (Cath > 0)) :
        Cath -= 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    while ((scribus.textOverflows(shpShapeNameCat) > 0)) :
        Cath += 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    global strCatalogHeight
    strCatalogHeight = Cath

    '''Place the Caption, if not already placed'''
    if strTitleInclude == 'FALSE':
        if strDateInclude == 'FALSE':
            if strCaptionInclude == 'TRUE':
                if strLayoutCaption == 'Top':
                    funcCaptionTop()
                elif strLayoutCaption == 'Right':
                    funcCaptionRight()
                elif strLayoutCaption == 'Bottom':
                    funcCaptionBottom()
                elif strLayoutCaption == 'Left':
                    funcCaptionLeft() 

def funcCatalogBottom():
    strCatalogWidth = (round(float(strFrameOuterWidth) * float(strCatalogRatio) / 100, 4))
    strCatalogHeight = float(10)
    strCatalogShift = (round(float(strCatalogWidth - strFrameOuterWidth) / 2, 4))
    strCatalogLeft = (round(float(strPlacementX - strCatalogShift), 4))
    global shpShapeNameCat
    shpShapeNameCat = scribus.createText(strCatalogLeft, strPlacementY, strCatalogWidth, strCatalogHeight)
    
    scribus.setText(strCatalog, shpShapeNameCat) 
    if strCatalogStyle == 'Global':
        TextLengthCat = scribus.getTextLength(shpShapeNameCat)
        scribus.selectText(0,TextLengthCat,shpShapeNameCat)
        scribus.setStyle("Catalog",shpShapeNameCat)
    else:
        scribus.setFont(strCatalogFont, shpShapeNameCat)
        scribus.setFontSize(float(strCatalogFontSize), shpShapeNameCat)
        if strCatalogTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCat)
        elif strCatalogTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCat)
        elif strCatalogTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCat)
        elif strCatalogTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCat)    
        scribus.setLineSpacing(float(strCatalogFontSize)*float(1.15), shpShapeNameCat)
    
    (Catw, Cath) = scribus.getSize(shpShapeNameCat)
    while (((scribus.textOverflows(shpShapeNameCat) == 0)) and (Cath > 0)) :
        Cath -= 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    while ((scribus.textOverflows(shpShapeNameCat) > 0)) :
        Cath += 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    global strCatalogHeight
    strCatalogHeight = Cath

    '''Place the Caption, if not already placed'''
    if strTitleInclude == 'FALSE':
        if strDateInclude == 'FALSE':
            if strCaptionInclude == 'TRUE':
                if strLayoutCaption == 'Top':
                    funcCaptionTop()
                elif strLayoutCaption == 'Right':
                    funcCaptionRight()
                elif strLayoutCaption == 'Bottom':
                    funcCaptionBottom()
                elif strLayoutCaption == 'Left':
                    funcCaptionLeft() 

def funcCatalogLeft():
    strCatalogWidth = (round(float(strFrameOuterWidth) * float(strCatalogRatio) / 100, 4))
    strCatalogHeight = float(10)
    strCatalogLeft = (round(float(strPlacementX  - strCatalogWidth - strMarginRight), 4))
    global shpShapeNameCat
    shpShapeNameCat = scribus.createText(strCatalogLeft, strPlacementY, strCatalogWidth, strCatalogHeight)
    
    scribus.setText(strCatalog, shpShapeNameCat) 
    if strCatalogStyle == 'Global':
        TextLengthCat = scribus.getTextLength(shpShapeNameCat)
        scribus.selectText(0,TextLengthCat,shpShapeNameCat)
        scribus.setStyle("Catalog",shpShapeNameCat)
    else:
        scribus.setFont(strCatalogFont, shpShapeNameCat)
        scribus.setFontSize(float(strCatalogFontSize), shpShapeNameCat)
        if strCatalogTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCat)
        elif strCatalogTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCat)
        elif strCatalogTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCat)
        elif strCatalogTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCat)    
        scribus.setLineSpacing(float(strCatalogFontSize)*float(1.15), shpShapeNameCat)
    
    (Catw, Cath) = scribus.getSize(shpShapeNameCat)
    while (((scribus.textOverflows(shpShapeNameCat) == 0)) and (Cath > 0)) :
        Cath -= 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    while ((scribus.textOverflows(shpShapeNameCat) > 0)) :
        Cath += 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    global strCatalogHeight
    strCatalogHeight = Cath

    '''Place the Caption, if not already placed'''
    if strTitleInclude == 'FALSE':
        if strDateInclude == 'FALSE':
            if strCaptionInclude == 'TRUE':
                if strLayoutCaption == 'Top':
                    funcCaptionTop()
                elif strLayoutCaption == 'Right':
                    funcCaptionRight()
                elif strLayoutCaption == 'Bottom':
                    funcCaptionBottom()
                elif strLayoutCaption == 'Left':
                    funcCaptionLeft()

def funcCatalogCenter():
    if strFrameDouble == 'TRUE':
        strCatalogWidth = (round(float(strFrameInnerWidth - strPaddingLeft - strPaddingLeft) * float(.90), 4))
    else:
        strCatalogWidth = (round(float(strFrameOuterWidth - strPaddingLeft - strPaddingLeft) * float(.90), 4))
    strCatalogHeight = float(10)
    strCatalogShift = (round(float(strCatalogWidth - strFrameOuterWidth) / 2, 4))
    strCatalogLeft = (round(float(strPlacementX  - strCatalogShift), 4))
    global shpShapeNameCat
    shpShapeNameCat = scribus.createText(strCatalogLeft, strPlacementY, strCatalogWidth, strCatalogHeight)
    
    scribus.setText(strCatalog, shpShapeNameCat)
    if strCatalogStyle == 'Global':
        TextLengthCat = scribus.getTextLength(shpShapeNameCat)
        scribus.selectText(0,TextLengthCat,shpShapeNameCat)
        scribus.setStyle("Catalog",shpShapeNameCat)
    else:
        scribus.setFont(strCatalogFont, shpShapeNameCat)
        scribus.setFontSize(float(strCatalogFontSize), shpShapeNameCat)
        if strCatalogTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCat)
        elif strCatalogTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCat)
        elif strCatalogTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCat)
        elif strCatalogTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCat)    
        scribus.setLineSpacing(float(strCatalogFontSize)*float(1.15), shpShapeNameCat)
    
    (Catw, Cath) = scribus.getSize(shpShapeNameCat)
    while (((scribus.textOverflows(shpShapeNameCat) == 0)) and (Cath > 0)) :
        Cath -= 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    while ((scribus.textOverflows(shpShapeNameCat) > 0)) :
        Cath += 1
        scribus.sizeObject(Catw, Cath, shpShapeNameCat)
    global strCatalogHeight
    strCatalogHeight = Cath

    '''Place the Caption, if not already placed'''
    if strTitleInclude == 'FALSE':
        if strDateInclude == 'FALSE':
            if strCaptionInclude == 'TRUE':
                if strLayoutCaption == 'Top':
                    funcCaptionTop()
                elif strLayoutCaption == 'Right':
                    funcCaptionRight()
                elif strLayoutCaption == 'Bottom':
                    funcCaptionBottom()
                elif strLayoutCaption == 'Left':
                    funcCaptionLeft()

def funcCatalogPlacement():
    if strCatalogInclude == 'TRUE':
        if strStyle == 'Inside':
            global strCatalogTop
            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - strCatalogHeight) / 2)),4))
        else:
            if strLayoutCatalog == 'Top':
                if strCaptionInclude == 'TRUE':
                    if strLayoutCaption == 'Top':
                        global strCatalogTop
                        strCatalogTop = (round(float(strPlacementY - strMarginTop - 
                        strCatalogHeight - strCaptionHeight - strVerticalSpacing),4))
                    else:
                        global strCatalogTop
                        strCatalogTop = (round(float(strPlacementY - strMarginTop - 
                        strCatalogHeight),4))
                else:
                    global strCatalogTop
                    strCatalogTop = (round(float(strPlacementY - strMarginTop - strCatalogHeight),4))
            elif strLayoutCatalog == 'Right':
                if strTitleInclude == 'TRUE':
                    if strLayoutTitle == 'Right':
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Right':
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                                strRightOverallHeight) / 2) + strRightTitleHeight + 
                                strRightDateHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                                strRightOverallHeight) / 2) + strRightTitleHeight + 
                                strVerticalSpacing),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                            strRightOverallHeight) / 2) + strRightTitleHeight + 
                            strVerticalSpacing),4))
                    else:
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Right':
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                                strRightOverallHeight) / 2) + strRightDateHeight + 
                                strVerticalSpacing),4))
                            else:
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                                strRightOverallHeight) / 2)),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                            strRightOverallHeight) / 2)),4))
                else:
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Right':
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                            strRightOverallHeight) / 2) + strRightDateHeight + 
                            strVerticalSpacing),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                            strRightOverallHeight) / 2)),4))
                    else:
                        global strCatalogTop
                        strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight - 
                        strRightOverallHeight) / 2)),4))               
            elif strLayoutCatalog == 'Bottom':
                if strTitleInclude == 'TRUE':
                    if strLayoutTitle == 'Bottom':
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Bottom':
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                                strMarginBottom + strTitleHeight + strDateHeight + 
                                (strVerticalSpacing * 2)),4))
                            else:
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                                strMarginBottom + strTitleHeight + strVerticalSpacing),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                            strMarginBottom + strTitleHeight + strVerticalSpacing),4))
                    else:
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Bottom':
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                                strMarginBottom + strDateHeight + strVerticalSpacing),4))
                            else:
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                                strMarginBottom),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                            strMarginBottom),4))
                else:
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Bottom':
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                            strMarginBottom + strDateHeight + strVerticalSpacing),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                            strMarginBottom),4))
                    else:
                        global strCatalogTop
                        strCatalogTop = (round(float(strPlacementY + strFrameOuterHeight +
                        strMarginBottom),4))
            elif strLayoutCatalog == 'Left':
                if strTitleInclude == 'TRUE':
                    if strLayoutTitle == 'Left':
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Left':
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2) + strLeftTitleHeight + strLeftDateHeight +
                                (strVerticalSpacing * 2)),4))
                            else:
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2) + strLeftTitleHeight + strVerticalSpacing),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                            strLeftOverallHeight) / 2) + strLeftTitleHeight + strVerticalSpacing),4))
                    else:
                        if strDateInclude == 'TRUE':
                            if strLayoutDate == 'Left':
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2) + strLeftDateHeight + strVerticalSpacing),4))
                            else:
                                global strCatalogTop
                                strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2)),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                            strLeftOverallHeight) / 2)),4))
                else:
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Left':
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                            strLeftOverallHeight) / 2) + strLeftDateHeight + strVerticalSpacing),4))
                        else:
                            global strCatalogTop
                            strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                            strLeftOverallHeight) / 2)),4))
                    else:
                        global strCatalogTop
                        strCatalogTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                        strLeftOverallHeight) / 2)),4))
    
        strCatalogOffset = strCatalogTop - strPlacementY
        scribus.moveObject(0, strCatalogOffset, shpShapeNameCat) 
    elif strCatalogIncludeX == 'TRUE':
        if strStyle == 'Outside/Inside':
            if strPhotoInclude == 'TRUE':
                global strPhotoPosnY
                strPhotoPosnY = scribus.getProperty(shpShapeNameP, "yPos")
                global strCatalogTop
                strCatalogTop = (round(float(strPhotoPosnY),4))
                scribus.setProperty(shpShapeNameCat, "yPos", strCatalogTop + strPhotoHeight + strOISpacing)
            else:
                global strCatalogInclude
                strCatalogInclude = 'TRUE'
                global strCatalogIncludeX
                strCatalogIncludeX = 'FALSE'
                global strStyle
                strStyle = 'Inside'
                funcCatalogPlacement()

def funcCaptionTop():
    strCaptionWidth = (round(float(strFrameOuterWidth) * float(strCaptionRatio) / 100, 4))
    strCaptionHeight = float(10)
    strCaptionShift = (round(float(strCaptionWidth - strFrameOuterWidth) / 2, 4))
    strCaptionLeft = (round(float(strPlacementX  - strCaptionShift), 4))
    global shpShapeNameCap
    shpShapeNameCap = scribus.createText(strCaptionLeft, strPlacementY, strCaptionWidth, strCaptionHeight)
    
    scribus.setText(strCaption, shpShapeNameCap)
    if strCaptionStyle == 'Global':
        TextLengthCap = scribus.getTextLength(shpShapeNameCap)
        scribus.selectText(0,TextLengthCap,shpShapeNameCap)
        scribus.setStyle("Caption",shpShapeNameCap)
    else:
        scribus.setFont(strCaptionFont, shpShapeNameCap)
        scribus.setFontSize(float(strCaptionFontSize), shpShapeNameCap)
        if strCaptionTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCap)
        elif strCaptionTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCap)
        elif strCaptionTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCap)
        elif strCaptionTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCap)    
        scribus.setLineSpacing(float(strCaptionFontSize)*float(1.15), shpShapeNameCap)
    
    (Capw, Caph) = scribus.getSize(shpShapeNameCap)
    while (((scribus.textOverflows(shpShapeNameCap) == 0)) and (Caph > 0)) :
        Caph -= 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    while ((scribus.textOverflows(shpShapeNameCap) > 0)) :
        Caph += 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    global strCaptionHeight
    strCaptionHeight = Caph 

def funcCaptionRight():
    strCaptionWidth = (round(float(strFrameOuterWidth) * float(strCaptionRatio) / 100, 4))
    strCaptionHeight = float(10)
    strCaptionLeft = (round(float(strPlacementX  + strFrameOuterWidth + strMarginRight), 4))
    global shpShapeNameCap
    shpShapeNameCap = scribus.createText(strCaptionLeft, strPlacementY, strCaptionWidth, strCaptionHeight)
    
    scribus.setText(strCaption, shpShapeNameCap)
    if strCaptionStyle == 'Global':
        TextLengthCap = scribus.getTextLength(shpShapeNameCap)
        scribus.selectText(0,TextLengthCap,shpShapeNameCap)
        scribus.setStyle("Caption",shpShapeNameCap)
    else:
        scribus.setFont(strCaptionFont, shpShapeNameCap)
        scribus.setFontSize(float(strCaptionFontSize), shpShapeNameCap)
        if strCaptionTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCap)
        elif strCaptionTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCap)
        elif strCaptionTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCap)
        elif strCaptionTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCap)    
        scribus.setLineSpacing(float(strCaptionFontSize)*float(1.15), shpShapeNameCap)
    
    (Capw, Caph) = scribus.getSize(shpShapeNameCap)
    while (((scribus.textOverflows(shpShapeNameCap) == 0)) and (Caph > 0)) :
        Caph -= 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    while ((scribus.textOverflows(shpShapeNameCap) > 0)) :
        Caph += 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    global strCaptionHeight
    strCaptionHeight = Caph 

def funcCaptionBottom():
    strCaptionWidth = (round(float(strFrameOuterWidth) * float(strCaptionRatio) / 100, 4))
    strCaptionHeight = float(10)
    strCaptionShift = (round(float(strCaptionWidth - strFrameOuterWidth) / 2, 4))
    strCaptionLeft = (round(float(strPlacementX  - strCaptionShift), 4))
    global shpShapeNameCap
    shpShapeNameCap = scribus.createText(strCaptionLeft, strPlacementY, strCaptionWidth, strCaptionHeight)
    
    scribus.setText(strCaption, shpShapeNameCap)
    if strCaptionStyle == 'Global':
        TextLengthCap = scribus.getTextLength(shpShapeNameCap)
        scribus.selectText(0,TextLengthCap,shpShapeNameCap)
        scribus.setStyle("Caption",shpShapeNameCap)
    else:
        scribus.setFont(strCaptionFont, shpShapeNameCap)
        scribus.setFontSize(float(strCaptionFontSize), shpShapeNameCap)
        if strCaptionTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCap)
        elif strCaptionTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCap)
        elif strCaptionTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCap)
        elif strCaptionTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCap)    
        scribus.setLineSpacing(float(strCaptionFontSize)*float(1.15), shpShapeNameCap)
    
    (Capw, Caph) = scribus.getSize(shpShapeNameCap)
    while (((scribus.textOverflows(shpShapeNameCap) == 0)) and (Caph > 0)) :
        Caph -= 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    while ((scribus.textOverflows(shpShapeNameCap) > 0)) :
        Caph += 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    global strCaptionHeight
    strCaptionHeight = Caph 

def funcCaptionLeft():
    strCaptionWidth = (round(float(strFrameOuterWidth) * float(strCaptionRatio) / 100, 4))
    strCaptionHeight = float(10)
    strCaptionLeft = (round(float(strPlacementX  - strCaptionWidth - strMarginRight), 4))
    global shpShapeNameCap
    shpShapeNameCap = scribus.createText(strCaptionLeft, strPlacementY, strCaptionWidth, strCaptionHeight)
    
    scribus.setText(strCaption, shpShapeNameCap)
    if strCaptionStyle == 'Global':
        TextLengthCap = scribus.getTextLength(shpShapeNameCap)
        scribus.selectText(0,TextLengthCap,shpShapeNameCap)
        scribus.setStyle("Caption",shpShapeNameCap)
    else:
        scribus.setFont(strCaptionFont, shpShapeNameCap)
        scribus.setFontSize(float(strCaptionFontSize), shpShapeNameCap)
        if strCaptionTextAlign == 'Left':
            scribus.setTextAlignment(0, shpShapeNameCap)
        elif strCaptionTextAlign == "Center":
            scribus.setTextAlignment(1, shpShapeNameCap)
        elif strCaptionTextAlign == 'Right':
            scribus.setTextAlignment(2, shpShapeNameCap)
        elif strCaptionTextAlign == "Justified":
            scribus.setTextAlignment(3, shpShapeNameCap)    
        scribus.setLineSpacing(float(strCaptionFontSize)*float(1.15), shpShapeNameCap)
    
    (Capw, Caph) = scribus.getSize(shpShapeNameCap)
    while (((scribus.textOverflows(shpShapeNameCap) == 0)) and (Caph > 0)) :
        Caph -= 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    while ((scribus.textOverflows(shpShapeNameCap) > 0)) :
        Caph += 1
        scribus.sizeObject(Capw, Caph, shpShapeNameCap)
    global strCaptionHeight
    strCaptionHeight = Caph 

def funcCaptionPlacement():
    if strCaptionInclude == 'TRUE':
        if strLayoutCaption == 'Top':
            global strCaptionTop
            strCaptionTop = (round(float(strPlacementY - strMarginTop - strCaptionHeight),4))
        elif strLayoutCaption == 'Right':
            if strTitleInclude == 'TRUE':
                if strLayoutTitle == 'Right':
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Right':
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Right':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strRightOverallHeight) / 2) + strRightTitleHeight + 
                                    strRightDateHeight + strRightCatalogHeight + 
                                    (strVerticalSpacing * 3)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strRightOverallHeight) / 2) + strRightTitleHeight + 
                                    strRightDateHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strRightOverallHeight) / 2) + strRightTitleHeight + 
                                strRightDateHeight + (strVerticalSpacing * 2)),4))
                        else:
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Right':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                    strRightTitleHeight + strRightCatalogHeight + 
                                    (strVerticalSpacing * 2)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                    strRightTitleHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                strRightTitleHeight + strVerticalSpacing),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Right':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                strRightTitleHeight + strRightCatalogHeight + 
                                (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                strRightTitleHeight + strVerticalSpacing),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                            strRightTitleHeight + strVerticalSpacing),4))
                else:
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Right':
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Right':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strRightOverallHeight) / 2) + strRightDateHeight + 
                                    strRightCatalogHeight + (strVerticalSpacing * 2)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strRightOverallHeight) / 2) + strRightDateHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strRightOverallHeight) / 2) + strRightDateHeight + strVerticalSpacing),4))
                        else:
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Right':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                    strRightCatalogHeight + strVerticalSpacing),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Right':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                strRightCatalogHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))
            else:
                if strDateInclude == 'TRUE':
                    if strLayoutDate == 'Right':
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Right':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strRightOverallHeight) / 2) + strRightDateHeight + 
                                strRightCatalogHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strRightOverallHeight) / 2) + strRightDateHeight + strVerticalSpacing),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                            strRightOverallHeight) / 2) + strRightDateHeight + strVerticalSpacing),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Right':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                                strRightCatalogHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))
                else:
                    if strCatalogInclude == 'TRUE':
                        if strLayoutCatalog == 'Right':
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strRightOverallHeight) / 2) +
                            strRightCatalogHeight + (strVerticalSpacing * 2)),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))
                    else:
                        global strCaptionTop
                        strCaptionTop = (round(float(strPlacementY + 
                        ((strFrameOuterHeight - strRightOverallHeight) / 2)),4))         
        elif strLayoutCaption == 'Bottom':
            if strTitleInclude == 'TRUE':
                if strLayoutTitle == 'Bottom':
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Bottom':
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Bottom':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                    strDateHeight + strCatalogHeight + (strVerticalSpacing * 3)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                    strDateHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                strDateHeight + (strVerticalSpacing * 2)),4))
                        else:
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Bottom':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                    strCatalogHeight + (strVerticalSpacing * 2)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                    strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                strVerticalSpacing),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Bottom':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                strCatalogHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom + strTitleHeight +
                                strVerticalSpacing),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            strFrameOuterHeight + strMarginBottom + strTitleHeight +
                            strVerticalSpacing),4))
                else:
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Bottom':
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Bottom':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom + strDateHeight +
                                    strCatalogHeight + (strVerticalSpacing * 2)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom +
                                    strDateHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom +
                                strDateHeight + strVerticalSpacing),4))
                        else:
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Bottom':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom +
                                    strCatalogHeight + strVerticalSpacing),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    strFrameOuterHeight + strMarginBottom +
                                    strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom +
                                strVerticalSpacing),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Bottom':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom +
                                strCatalogHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            strFrameOuterHeight + strMarginBottom),4))
            else:
                if strDateInclude == 'TRUE':
                    if strLayoutDate == 'Bottom':
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Bottom':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom +
                                strDateHeight + strCatalogHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom +
                                strDateHeight + strVerticalSpacing),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            strFrameOuterHeight + strMarginBottom +
                            strDateHeight + strVerticalSpacing),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Bottom':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom +
                                strCatalogHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                strFrameOuterHeight + strMarginBottom),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            strFrameOuterHeight + strMarginBottom),4))
                else:
                    if strCatalogInclude == 'TRUE':
                        if strLayoutCatalog == 'Bottom':
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            strFrameOuterHeight + strMarginBottom + 
                            strCatalogHeight + strVerticalSpacing),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            strFrameOuterHeight + strMarginBottom),4))
                    else:
                        global strCaptionTop
                        strCaptionTop = (round(float(strPlacementY + 
                        strFrameOuterHeight + strMarginBottom),4))
        elif strLayoutCaption == 'Left':
            if strTitleInclude == 'TRUE':
                if strLayoutTitle == 'Left':
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Left':
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Left':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strLeftOverallHeight) / 2) + strLeftTitleHeight + 
                                    strLeftDateHeight + strLeftCatalogHeight + 
                                    (strVerticalSpacing * 3)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strLeftOverallHeight) / 2) + strLeftTitleHeight + 
                                    strLeftDateHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2) + strLeftTitleHeight + 
                                strLeftDateHeight + (strVerticalSpacing * 2)),4))
                        else:
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Left':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                    strLeftTitleHeight + strLeftCatalogHeight + 
                                    (strVerticalSpacing * 2)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                    strLeftTitleHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                strLeftTitleHeight + strVerticalSpacing),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Left':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                strLeftTitleHeight + strLeftCatalogHeight + 
                                (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                strLeftTitleHeight + strVerticalSpacing),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                            strLeftTitleHeight + strVerticalSpacing),4))
                else:
                    if strDateInclude == 'TRUE':
                        if strLayoutDate == 'Left':
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Left':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strLeftOverallHeight) / 2) + strLeftDateHeight + 
                                    strLeftCatalogHeight + (strVerticalSpacing * 2)),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                    strLeftOverallHeight) / 2) + strLeftDateHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2) + strLeftDateHeight + strVerticalSpacing),4))
                        else:
                            if strCatalogInclude == 'TRUE':
                                if strLayoutCatalog == 'Left':
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                    strLeftCatalogHeight + strVerticalSpacing),4))
                                else:
                                    global strCaptionTop
                                    strCaptionTop = (round(float(strPlacementY + 
                                    ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Left':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                strLeftCatalogHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
            else:
                if strDateInclude == 'TRUE':
                    if strLayoutDate == 'Left':
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Left':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2) + strLeftDateHeight + 
                                strLeftCatalogHeight + (strVerticalSpacing * 2)),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                                strLeftOverallHeight) / 2) + strLeftDateHeight + strVerticalSpacing),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + ((strFrameOuterHeight -
                            strLeftOverallHeight) / 2) + strLeftDateHeight + strVerticalSpacing),4))
                    else:
                        if strCatalogInclude == 'TRUE':
                            if strLayoutCatalog == 'Left':
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                                strLeftCatalogHeight + strVerticalSpacing),4))
                            else:
                                global strCaptionTop
                                strCaptionTop = (round(float(strPlacementY + 
                                ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
                else:
                    if strCatalogInclude == 'TRUE':
                        if strLayoutCatalog == 'Left':
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strLeftOverallHeight) / 2) +
                            strLeftCatalogHeight + (strVerticalSpacing * 2)),4))
                        else:
                            global strCaptionTop
                            strCaptionTop = (round(float(strPlacementY + 
                            ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
                    else:
                        global strCaptionTop
                        strCaptionTop = (round(float(strPlacementY + 
                        ((strFrameOuterHeight - strLeftOverallHeight) / 2)),4))
                        
        strCaptionOffset = strCaptionTop - strPlacementY
        scribus.moveObject(0, strCaptionOffset, shpShapeNameCap) 
               
def funcCenterMiddles():
    global intR
    intR = 0
    global intL
    intL = 0   
    
    if strTitleInclude == 'TRUE':           
        if strLayoutTitle == 'Right':
            global strLeftTitleHeight
            strLeftTitleHeight = 0
            global strRightTitleHeight
            strRightTitleHeight = strTitleHeight
            global intR
            intR += 1
        elif strLayoutTitle == 'Left':
            global strLeftTitleHeight
            strLeftTitleHeight = strTitleHeight
            global strRightTitleHeight
            strRightTitleHeight = 0
            global intL
            intL += 1
        else:
            global strLeftTitleHeight
            strLeftTitleHeight = 0
            global strRightTitleHeight
            strRightTitleHeight = 0
    else:
        global strLeftTitleHeight
        strLeftTitleHeight = 0
        global strRightTitleHeight
        strRightTitleHeight = 0

    if strDateInclude == 'TRUE':           
        if strLayoutDate == 'Right':
            global strLeftDateHeight
            strLeftDateHeight = 0
            global strRightDateHeight
            strRightDateHeight = strDateHeight
            global intR
            intR += 1
        elif strLayoutDate == 'Left':
            global strLeftDateHeight
            strLeftDateHeight = strDateHeight
            global strRightDateHeight
            strRightDateHeight = 0
            global intL
            intL += 1
        else:
            global strLeftDateHeight
            strLeftDateHeight = 0
            global strRightDateHeight
            strRightDateHeight = 0
    else:
        global strLeftDateHeight
        strLeftDateHeight = 0
        global strRightDateHeight
        strRightDateHeight = 0

    if strCatalogInclude == 'TRUE':           
        if strLayoutCatalog == 'Right':
            global strLeftCatalogHeight
            strLeftCatalogHeight = 0
            global strRightCatalogHeight
            strRightCatalogHeight = strCatalogHeight
            global intR
            intR += 1
        elif strLayoutCatalog == 'Left':
            global strLeftCatalogHeight
            strLeftCatalogHeight = strCatalogHeight
            global strRightCatalogHeight
            strRightCatalogHeight = 0
            global intL
            intL += 1
        else:
            global strLeftCatalogHeight
            strLeftCatalogHeight = 0
            global strRightCatalogHeight
            strRightCatalogHeight = 0
    else:
        global strLeftCatalogHeight
        strLeftCatalogHeight = 0
        global strRightCatalogHeight
        strRightCatalogHeight = 0

    if strCaptionInclude == 'TRUE':           
        if strLayoutCaption == 'Right':
            global strLeftCaptionHeight
            strLeftCaptionHeight = 0
            global strRightCaptionHeight
            strRightCaptionHeight = strCaptionHeight
            global intR
            intR += 1
        elif strLayoutCaption == 'Left':
            global strLeftCaptionHeight
            strLeftCaptionHeight = strCaptionHeight
            global strRightCaptionHeight
            strRightCaptionHeight = 0
            global intL
            intL += 1
        else:
            global strLeftCaptionHeight
            strLeftCaptionHeight = 0
            global strRightCaptionHeight
            strRightCaptionHeight = 0
    else:
        global strLeftCaptionHeight
        strLeftCaptionHeight = 0
        global strRightCaptionHeight
        strRightCaptionHeight = 0
    
    if intL > 0:
        global strLeftOverallHeight
        strLeftOverallHeight = strLeftTitleHeight + strLeftDateHeight + strLeftCatalogHeight + strLeftCaptionHeight + ((intL - 1) * strVerticalSpacing)
    if intR > 0:
        global strRightOverallHeight
        strRightOverallHeight = strRightTitleHeight + strRightDateHeight + strRightCatalogHeight + strRightCaptionHeight + ((intR - 1) * strVerticalSpacing)    
               
def funcGroupAndAlign(): 
    funcTitlePlacement()
    funcDatePlacement()
    funcCatalogPlacement()
    funcCaptionPlacement()
    
    global lstObject    
    lstObjects=[shpShapeNameFo, shpShapeNameFi, shpShapeNameP, shpShapeNameT, shpShapeNameD, shpShapeNameCat, shpShapeNameCap]
    scribus.groupObjects(lstObjects)
    
funcImportSettings()
